//----------------------------------------------------------------
/* 七並べ
/* 1991/2/21 - 2/28
/* Oh!X 1991/8
// V3.20以降専用
//----------------------------------------------------------------

// iPadのみ
if not checkCompatible(COMPATIBLE_IPAD) then stop

if cardInit()<>0 then {
	print localizedString("カードパターンが読めません","Card data can not read.")
	end
}
tColorPaletX68(1,&hff0000ff)

//----------------------------------------------------------------
// 以下ゲーム実体
//----------------------------------------------------------------
// お約束部分
enum
	FNTSZ=16
	KEY_SPACE=' '
endenum
str FONT="Migu-1M-Regular"

font(FONT,FNTSZ):// 先にフォントを設定してからwidth()を設定する
width(96):// テキスト文字フォントサイズを算出させる
// 以下テキスト描画はグラフィックモードで行う(X68のプログラムのままではグラフィックとテキストで座標が合わないので)
width(0)
tAtrb(ATRB_CLEAR):// グラフィックモードでテキスト文字の下地を消す

vpriority(TPAGE,GPAGE0,GPAGE1,GPAGE2,GPAGE3)
vpage(B_TPAGE+B_GPAGE0+B_GPAGE1+B_GPAGE2+B_GPAGE3)

// bitmapOpen()はページ毎に行う必要がある
apage(GPAGE3):bitmapOpen(0,0,YES)
apage(GPAGE2):bitmapOpen(0,0,YES)
apage(GPAGE1):bitmapOpen(0,0,YES)
apage(GPAGE0):bitmapOpen(0,0,YES)

// これがないと任意のタッチ座標を得られない / Need for getting any touch coordinate
setTouchArea(0,0,0,0,0,NO)

dim int	touchNo(20)	:// タッチエリア番号 / touch area number
int touchallcnt=0	:// タッチエリア数   / the number of touch area

//----------------------------------------------------------------

dim int card(51),ba(51)
dim player(4,10),pass(4),numc(4),win(4)
dim str nm(4)={"あなた","マイペース","風見鶏","意地悪","一直線"}
int mx,my,bl,br
int times,winner
dim str mes(4)={"",
		"もう一度プレイしますか。左クリックでもう一度、右クリックで終了です。",	// 未使用
		"出すカードをタップしてください。パスは「パス」ボタンです",
		"まず７を出します、ダイヤの７を出した人からゲーム開始です。",
		"まだ出せましたよ。"
		}
if not isLocalizeJapan() then {
	nm={"You","My pace","Weathercock","So mean","One-track"}
	mes={"",
		"",	// 未使用
		"Please tap selcted card. If you want to pass, push 'Pass' button.",
		"First, you must throw card #7. Start a game from the people that throw the 7 of diamonds.",
		"You were able to throw yet."
		}
}
mes(0)=space$(95)

//------------------------------------
/* main
//------------------------------------

// 音声データ読み込み
dim int snd(5)
enum
	// 音番号の定義
	shan=1
	don
	pinpon
	da
	agari
endenum
int i
for i=1 to 5
//	gLocate(0,35+i)
//	print "7_"+str$(i)+".mp3";
	snd(i)=a_setPlayData("7_"+str$(i)+".mp3")
//	print "/";snd(i)
next

init1()
setFunctionKey(0,localizedString("パス","Pass"),'P')
displayFunctionKey(YES,0,0)

repeat
	init2()
	winner = game()
	gameover(winner)
until replay()=0

displayFunctionKey(NO)

// 音声バッファー開放
for i=1 to 5
	a_end(snd(i))
next

// bitmapはページごとに確保されているので、それぞれを開放する必要がある
apage(GPAGE3):bitmapClose()
apage(GPAGE2):bitmapClose()
apage(GPAGE1):bitmapClose()
apage(GPAGE0):bitmapClose()

end

//------------------------------------
/* 初期設定1(1回のみ)
//------------------------------------

func init1()
int i
	randomize(val(mid$(time$,4,2)+right$(time$,2)))
	setgPalet16X68(1,&h000000ff):// palet(1,0)

	times=0
	for i=0 to 51
		card(i)=i+1
	next
	for i=0 to 4
		win(i)=0
	next
endfunc

//------------------------------------
/*  初期設定2(1ゲーム毎)
//------------------------------------

func init2()
int i
	cls()
	fill16X68(0,  0, 768,1023, 8)
//	fill16X68(0,  0,1023,1023, 8)
	fill16X68(0,392, 767, 393,14):// 上下境界線
	times=times+1
	for i=0 to 4
		pass(i)=0:numc(i)=0
	next
	for i=0 to 51
		ba(i)=0
	next
	sfl(52)
	deal()
endfunc

//------------------------------------
/* シャッフル
//------------------------------------

func sfl(n;int)
int a,b,c,i
	for i=0 to 99
		a=rnd()*n:b=rnd()*n
		c=card(a)
		card(a)=card(b)
		card(b)=c
	next
endfunc

//------------------------------------
/* カードを配る
//------------------------------------

func deal()
int i,j,k,l
	for i=0 to 4
		for j=0 to 10
			player(i,j)=-1
		next
	next
	i=0
	j=rnd()*6
	for k=0 to 10
		for l=0 to 4
			player((j+l) mod 5,k)=card(i)
			numc((j+l) mod 5)=numc((j+l) mod 5)+1
			i=i+1
			if i>51 then break
		next
	next
	sort()
endfunc

//------------------------------------
/* プレイヤーのカードをソート
//------------------------------------

func sort()
int c,i,j
	for i=0 to 9
		for j=i+1 to 10
		if ((player(0,i)>player(0,j)) and (player(0,j)>-1)) or (player(0,i)=-1) then {
			c=player(0,i)
			player(0,i)=player(0,j)
			player(0,j)=c
		}
		next
	next
endfunc

//------------------------------------
/* ゲーム
//------------------------------------

func int game()
int i,p,w
	for i=0 to 4
		prstat(i)
	next
	pcput()
	p=put7()
	repeat
		if pass(p)<=3 then {
			mark(p)
			switch p
				case 0 : i=man():break
				case 1 : i=com1(p):break
				case 2 : i=com2(p):break
				case 3 : i=com3(p):break
				case 4 : i=com4(p):break
			endswitch
			if i = -1 then {
				oto(da)
				pass(p)=pass(p)+1
				if pass(p)>3 then {
					dead(p)
				} else {
					prstat(p)
				}
			} else {
				cdasu(p,i)
				if numc(p)=1 then oto(pinpon)
			}
			erase(p)
		}
		w=judge(p,i)
		p=p+1
		if p>4 then p=0
	until w<>-1
	return(w)
endfunc

//------------------------------------
/* ステータス表示
//------------------------------------

func prstat(n;int)
int  y
	y=calcy(n)
	tColorX68(6):gLocate(81,y):print nm(n)
	gLocate(81,y+1):tColorX68(7)
	switch numc(n)
		case 0 : break
		case 1 : print       localizedString(" あ と 一 枚 ","last card"):break
		default:
			if isLocalizeJapan() then {
				print using "残り       ##";numc(n)
			} else {
				print using "Left      ##";numc(n)
			}
			break
	endswitch
	switch pass(n)
		case 2 : tColorX68(6):break
		case 3 : tColorX68(5):break
		default: tColorX68(7)
	endswitch
	gLocate(81,y+2)
	if isLocalizeJapan() then {
		print using "パス      ##";pass(n)
	} else {
		print using "Pass     ##";pass(n)
	}
	tColorX68(7):gLocate(81,y+3)
	if isLocalizeJapan() then {
		print using "勝ち数    ##";win(n)
	} else {
		print using "Wins     ##";win(n)
	}
endfunc

//------------------------------------
/* プレイヤーのカード表示
//------------------------------------

func pcput()
int i
	for i=0 to 10
		switch player(0,i)
			case -1 : carddel(i):break
			default : cardPut(i*CARD_WX,416,player(0,i),NO)
		endswitch
	next
endfunc

//------------------------------------
/* カードを消す
//------------------------------------

func carddel(x;int)
	fill16X68(x*CARD_WX,416,x*CARD_WX+CARD_WX,511,8)
endfunc

//------------------------------------
/* ７を出す
//------------------------------------

func int put7()
int i,j,p
	message(3)
	for i=0 to 4
		for j=0 to 10
			if number(player(i,j))=7 then {
				if player(i,j)=33 then p=i
				cdasu(i,j)
			}
		next
	next
	message(0)
	return(p)
endfunc

//------------------------------------
/* カードを出す
//------------------------------------

func cdasu(i;int,j;int)
	if i=0 then carddel(j)
	cdput(player(i,j))
	oto(shan)
	player(i,j)=-1
	numc(i)=numc(i)-1
	prstat(i)
	if i=0 then {
		sort()
		pcput()
	}
endfunc

//------------------------------------
/* 場にカード表示
//------------------------------------

func cdput(n;int)
	cardPut((number(n)-1)*CARD_WX,(n-1)/13*CARD_WY,n,NO)
	ba(n-1)=-1
endfunc

//------------------------------------
/* プレイヤールーチン
//------------------------------------

func int man()
int c
	message(2)
	while -1
		c=selcard()
		if c=-1 then break
		if chcard(player(0,c)) then break
	endwhile
	message(0)
	return(c)
endfunc

//------------------------------------
/* プレイヤーカード選択
//------------------------------------

func int selcard()
	button()
	if br then return(-1):// スキップ
	if bl and my>415 and mx/CARD_WX<11 then return(mx/CARD_WX)
endfunc

//------------------------------------
/* 指定のカードが出せるかどうか
//------------------------------------

func int chcard(c;int)
int i,j
	if c=-1 then return(0)
	i=number(c)
	if i<7 then j=1 else j=-1
	i=i+j:c=c+j
	while i<>7
		if ba(c-1)=0 then return(0)
		i=i+j:c=c+j
	endwhile
	return(-1)
endfunc

//------------------------------------
/* 終了判定
//------------------------------------

func int judge(p;int,i;int)
int j=-1
	if numc(p)=0 then return(p)
	if i<>-1 then return(-1)
	for p=0 to 4
		if pass(p)<=3 then {
			if j=-1 then j=p else return(-1)
		}
	next
	return(j)
endfunc

//------------------------------------
/* 破産
//------------------------------------

func dead(p;int)
int y,i,j,k
	for i=0 to 10
		for j=0 to 3
			for k=0 to 1
				if chcard(player(p,i)) then message(4)
			next
		next
	next
	y=calcy(p)+1
	for i=0 to 2
		gLocate(81,y+i):print space$(13)
	next
	oto(don)
	symbol16X68(632,y*16,localizedString("破産","bust"),3,5,FONT,FNTSZ)
	allput(p)
endfunc

//------------------------------------
/*  破産した時、すべてのカードを出す
//------------------------------------

func allput(p;int)
int i
	for i=0 to 10
		if player(p,i)<>-1 then {
			cdput(player(p,i))
			if p=0 then carddel(i)
		}
	next
endfunc

//------------------------------------
/* 1ゲーム終了
//------------------------------------

func gameover(p;int)
int y,i
	oto(agari)
	y=calcy(p)+1
	for i=0 to 2
		gLocate(81,y+i):print space$(13)
	next
	symbol16X68(632,y*16,localizedString("勝利","Win "),3,3,FONT,FNTSZ)
	win(p)=win(p)+1
	tColorX68(7)
	for i=0 to 4
		gLocate(81,calcy(i))
		if isLocalizeJapan() then {
			print using " ##戦 ##勝";times,win(i)
		} else {
			print using " ##wins ##loss";times,win(i)
		}
	next
endfunc

//------------------------------------
/* マウスのボタンが押されるまでウエイト
//------------------------------------

func button()
	kbclr()
	//
	br=0:bl=0
	while getTouchStatus()=TOUCH_NONE
		if inkey()='P' then {
			br=1
			return
		}
	endwhile
	//
	dim float tpoint(1)
	int touchCnt=getTouchPoint(tpoint)
	mx=tpoint(0)
	my=tpoint(1)
	bl=YES
	//
endfunc

//------------------------------------
/* もう一度プレイするか
//------------------------------------

func int replay()
	dim str menues(1)
	str title$
	if isLocalizeJapan() then {
		title$="もう一度、やりますか？"
		menues={"はい","いいえ"}
	} else {
		title$="Try again?"
		menues={"Yes","No"}
	}
	switch selectMenu(title$,menues)
		case 0
			return(YES)
	endswitch
	return(NO)
//	message(1)
//	button()
//	message(0)
//	if bl then return(-1)
//	return(0)
endfunc

//------------------------------------
/* メッセージを表示
//------------------------------------

func message(i;int)
	gLocate(0,25):tColorX68(7)
	print mes(i)
endfunc

//------------------------------------
/* 該当プレイヤーを明示
//------------------------------------

func mark(p;int)
int y
	y=calcy(p)*16
	fill16X68(648,y,752,y+15,3)
endfunc

//------------------------------------
/* マークを消す
//------------------------------------

func erase(p;int)
int y
	y=calcy(p)*16
	fill16X68(648,y,752,y+15,8)
endfunc

//------------------------------------
/* ｙ座標の計算
//------------------------------------

func int calcy(p;int)
int y
	switch p
		case 0 : y=27:break
		default: y=(p-1)*6+1
	endswitch
	return(y)
endfunc

//------------------------------------
/* 効果音
//------------------------------------

func oto(m;int)
	a_play(snd(m))
	while a_stat(snd(m))
	endwhile
endfunc

//------------------------------------
/* 思考ルーチン１(他のカードが出せるように出す)
//------------------------------------

func int think1(p;int)
int i,j,k=-1
	for i=0 to 10
	if chcard(player(p,i)) then {
		k=i
		for j = 8 to 10
			if i<>j and (player(p,i)-1)/13=(player(p,j)-1)/13 and sgn(number(player(p,i))-7)=sgn(number(player(p,j))-7) then return(i)
		next
	}
	next
	return(k)
endfunc

//------------------------------------
/* 思考ルーチン２(７から遠いカードから出す)
//------------------------------------

func int think2(p;int)
int i,j=-1
	for i=0 to 10
		if chcard(player(p,i)) then {
			if j=-1 then {
				j=i
			} else {
				if abs(number(player(p,i))-7)<abs(number(player(p,j))-7) then j=i
			}
		}
	next
	return(j)
endfunc

//------------------------------------
/* 思考ルーチン３(１＋２)
//------------------------------------

func int think3(p;int)
int i
	i=think1(p)
	if i<>-1 then return(i)
	return(think2(p))
endfunc

//------------------------------------
/* カード番号からカードの数を得る
//------------------------------------

func int number(i;int)
	return(((i-1) mod MAX_TRUMP)+1)
endfunc

//------------------------------------
/* コンピュータールーチン１
//------------------------------------

func int com1(p;int)
int i
	i=think1(p)
	if i<>-1 then return(i)
	i=think2(p)
	if i<>-1 then if pass(p)<2 and numc(p)>1 and abs(number(player(p,i))-7)<3 then return(-1)
	return(i)
endfunc

//------------------------------------
/* コンピュータールーチン２
//------------------------------------

func int com2(p;int)
int i
	for i=0 to 4
		if numc(i)=1 and i<>p and pass(p)<3 then return(-1)
	next
	for i=0 to 4
		if pass(i)<=pass(p) and i<>p then return(think3(p))
	next
	return(-1)
endfunc

//------------------------------------
/* コンピュータールーチン３
//------------------------------------

func int com3(p;int)
int i
	for i=0 to 10
		if chcard(player(p,i)) and abs(number(player(p,i))-7)>3 then return(i)
	next
	if pass(p)<3 and numc(p)>2 then return(-1)
	return(think3(p))
endfunc

//------------------------------------
/* コンピュータールーチン４
//------------------------------------

func int com4(p;int)
	return(think3(p))
endfunc

//****************************************************************

func removeKeys()
// 全タッチアリアの解除 / release all key touch area
// 毎回変わるので重要 / Important because stage is changed every time
	if touchallcnt>0 then {
		int i
		for i=1 to touchallcnt
			removeTouchArea(touchNo(i))
		next
		touchallcnt=0:// 登録してないの印
	}:// すでに解除済みの時は何もしない / if already released, do nothing.
endfunc

//****************************************************************
